// DIRE
// Libreria utilizada para manejar directorios

// (C) Anubis Software, Mayo 1995
#ifndef DIRE
#define DIRE

// ---------------------------------------+
// Inclusion de librerias Borland C++     |
// ---------------------------------------+

// ---------------------------------------+
// Inclusion de librerias Anubis soft     |
// ---------------------------------------+
#include "mdefs.h"


// ---------------------------------------+
// Definicion de las macros y constantes  |
// ---------------------------------------+
// Estas son las definiciones de errores
#define RUTA_INVALIDA1         2
#define RUTA_INVALIDA          3
#define ACCESO_DENEGADO        5
#define DIRECTORIO_ACTUAL      6
#define NO_COINCIDENCIA     0x12
#define DIRECTORIO_ACTUAL1    16
#define UNIDAD_INVALIDA       15
// Estas son las definiciones de tipos de ficheros para findfirst
#define NORMAL     0x00
#define S_LECTURA  0x01
#define OCULTO     0x02
#define SISTEMA    0x04
#define DIRECTORIO 0x10
#define ARCHIVO    0x20


// --------------------------------------+
// Definicion de tipos de la libreria    |
// --------------------------------------+
typedef struct  fblk   {
	char            ff_reserved[21];
	char            ff_attrib;
	unsigned        ff_ftime;
	unsigned        ff_fdate;
	long            ff_fsize;
	char            ff_name[13];
} mi_ffblk;


// ----------------------------------------+
// Definicion de constantes de la libreria |
// ----------------------------------------+
extern mi_ffblk FicheroActual;

// ----------------------------------------+
// Declaracin de las funciones            |
// ----------------------------------------+
// Esta funcion crea un subdirectorio
int mkdir(unsigned char *);

// Esta funcion borra un subdirectorio
int rmdir(unsigned char *);

// Esta funcion cambia el directorio actual
int chdir(unsigned char *);

// Esta funcion devuelve el directorio actual de la unidad especificada
// Nota: la letra del directorio debe ir en letras mayusculas 
// Ejemplo: A, B, C, D, E, ...
// Si se le pasa como parametro @ se devuelve el de la unidad por
// defecto.
int dir(unsigned char ,unsigned char *);

// Coge el primer fichero que cumple las
// especificaciones y lo almacena en la variable
// FicheroActual de esta libreria.
int findfirst(char *,WORD );

// Coge el siguiente archivo que cumpla
// las opciones determinadas y lo devuelve
// en la variable del sistema FicheroActual
// Si no se puede hacer, devuelve un error
int findnext(void);

// Esta funcion borra un fichero determinado
// el nombre del fichero no puede contener ni * ni ?
// Si el fichero se borra con exito devuelve 0
// sino devuelve un codigo de error
int del(char *);

// Establece como disco predeterminado el de
// la letra que se la pasa como parametro
// Tambien devuelve en numero de unidades 
// logicas del sistema
char setdisk(char );

// Devuelve la letra de la unidad de disco
char getdisk(void);

// Esta funcion obtiene cierta informacion del disco
// Si todo va bien, devuelve 0 y si no devuelve 0x0FFFF
// De la informacion dada se puede sacar la memoria disponible
int infdisk(unsigned char ,int *,int *,int *,int *);
   
#endif
