// GRAFIC1.H
// (C) Anubis Software Enero 1995
// Esta librera gestiona el uso de grficos, sin utilizar la BIOS
// con lo que la ganancia de tiempo es mayor. Y la versatilidad mejor.

#ifndef GRAFIC1.H
#define GRAFIC1.H
// -------------------------------+
// Librerias de BORLAND C++       |
// -------------------------------+
#include <dos.h>
#include <math.h>

// -------------------------------+
// Librerias de Anubis Software   |
// -------------------------------+
#include "mdefs.h"

// ---------------------------------------+
// Definicion de constantes               |
// ---------------------------------------+
#define IND_CONT_GRA    3ceh      //Registro ndice del controlador grfico
#define NUM_READ_MAP    4         //Nmero del registro READ-MAP
#define NUM_MODO_GRA    5         //Nmero del registro del modo grfico
#define NUM_BIT_MASK    8         //Nmero del registro de BIT-MASK
#define IND_REG_CRT     3d4h      //Registro ndice del controlador del CRT
#define NUM_REG_HI      0Ch       //Nmero del registro HI-START
#define VERT_RETRACE    3DAh      //Registro de estado de INPUT #1
// Definicion de tipos para el algoritmo de CohenSutherlandLineClipAndDraw
#define LEFT   1
#define RIGHT  2
#define BOTTOM 4
#define TOP    8

//----------------------------------------+
// Definicin de tipos de la librera     |
// ---------------------------------------+
typedef char outcode;

// ---------------------------------------+
// Definicin de variables de la librera |
// ---------------------------------------+
extern unsigned int SEG_VI   = 0x0A000;   //Segmento de vdeo con pgina activa
extern unsigned int ANCH_LIN = 0;         //Anchura de una lnea de puntos en bytes
extern unsigned int OFF_PAG  = 0;         //Offset de pgina

// ---------------------------------------+
// Declaracin de prototipos              |
// ---------------------------------------+
void modo320200(void);
void modo640480(void);
void modo640350(void);
void modo640200(void);
void ActPunto(int,int,unsigned char );
unsigned char LeePunto(int , int);
void MuestraPag(int);
void FijaPag(int);
void SwapInt(int *,int *);
void Linea(int,int, int,int,char);
void Rectangulo(int,int,int,int,int);
void CohenSutherlandLineClipAndDraw(double ,double ,double ,double ,double ,double ,double ,double ,int );
void Circulo(int ,int ,int ,char );


#endif
