// LISTAG.H

// NOTAS DE GRAN INTERES...
// Esta no es la lista convencional a la que estamos acostumbrados.
// La principal caracteristica radica en el hecho de que 
// ListaGenericaPrincipio no es un elemento de la lista mientras que
// ListaGenericaFinal si que lo es. 
// Justo lo contrario que en las listas convencionales.
// Para recorrer la lista completa se hace de la siguiente forma

// TipoElemento *elem=ListaGenericaPrincipio(lista);
// do {
// 	elem= ListaGenericaSiguiente(elem);
//		Tratamiento de elem como se quiera
//	}while (elem != ListaGenericaFinal(lista)


#ifndef LISTAG.H
#define LISTAG.H

// ----------------------------------------------+
// Inclusion de librerias BorlandC ++            |
// ----------------------------------------------+
#include <alloc.h>

// ----------------------------------------------+
// Inclusion de librerias Anubis Software        |
// ----------------------------------------------+
#include "generica.h"


// ----------------------------------------------+
// Definicion de constantes de la libreria       |
// ----------------------------------------------+
#define LISTAG_TODO_OK     				0
#define LISTAG_MEMORIA_INSUFICIENTE 	1

// ----------------------------------------------+
// Declaracion de tipos predefinidos por la lib  |
// ----------------------------------------------+
typedef struct  {
	TipoElemento *Inicio;
	TipoElemento *Ultimo;
} ListaGenerica;

// ----------------------------------------------+
// Declaracion de macros de la libreria          |
// ----------------------------------------------+
#define ListaGenericaPrincipio(x)   ((*x).Inicio)
#define ListaGenericaFinal(x)       ((*x).Ultimo)
#define ListaGenericaVacia(x)       ((*x).Inicio == (*x).Ultimo)
#define ListaGenericaSiguiente(x)   ((*x).Siguiente)
#define ListaGenericaElemento(x)    ((*x).Apuntador)

// ----------------------------------------------+
// Implementacion de las funciones de la libreria|
// ----------------------------------------------+
WORD ListaGenericaAnula( ListaGenerica *lista)
{
	TipoElemento *elem;
	elem= (TipoElemento *) malloc ( sizeof(TipoElemento));
	if (elem == NULL)
		return(LISTAG_MEMORIA_INSUFICIENTE);
	else  {
		(*lista).Inicio = elem;
		(*lista).Apuntador = elem;
		return(LISTAG_TODO_OK);
	}// end if
}// end ListaGenerica

WORD ListaGenericaAnade( ListaGenerica *lista, TipoElemento *posicion, void *apuntador)
{
	TipoElemento *elem;
	elem = (TipoElemento *) malloc (sizeof(TipoElemento));
	if (elem == NULL)
		return(LISTAG_MEMORIA_INSUFICIENTE);
	else  {
		(*elem).Siguiente = (*posicion).Siguiente;
		(*posicion).Siguiente = elem;
		if (posicion == ListaGenericaFinal(lista))
			(*lista).Ultimo = elem;
		return(LISTAG_TODO_OK);
	}// end if
}// end ListaGenericaAnade

void ListaGenericaElimina( ListaGenerica *lista, TipoElemento **posicion)
{
	TipoElemento * aux=ListaGenericaPrincipio(lista);
	while( *posicion != ListaGenericaSiguiente (aux))
		aux= ListaGenericaSiguiente(aux);
	(*aux).Siguiente = (*posicion).Siguiente;
	if(*posicion == ListaGenericaFinal(lista))
		(*lista).Ultimo = aux;
	free(*posicion);
	*posicion = (*aux).Siguiente;
}// end ListaGenericaElimina

TipoElemento *ListaGenericaAnterior( ListaGenerica *lista, TipoElemento *posicion)
{
	TipoElemento *aux=ListaGenericaPrincipio(lista);
	while( posicion != ListaGenericaSiguiente(aux))
		aux = ListaGenericaSiguiente(aux);
	return(aux);
}// end ListaGenericaAnterior
	