// LISTAG1.H

// NOTAS IMPORTANTES
// Esta si es una lista como dios manda que sean. Es decir que
// el primer elemento pertenece a la lista y el ltimo no.

#ifndef LISTAG1.H
#define LISTAG1.H

// ---------------------------------------+
// Inclusion de librerias BorlandC ++     |
// ---------------------------------------+
#include <alloc.h>

// ---------------------------------------+
// Inclusion de librerias Anubis Software |
// ---------------------------------------+
#include "mdefs.h"
#include "generica.h"

// ---------------------------------------+
// Constantes de la libreria              |
// ---------------------------------------+
#define LISTAG1_TODO_OK     				0
#define LISTAG1_MEMORIA_INSUFICIENTE 	1

// ---------------------------------------+
// Tipos predefinidos por la libreria     |
// ---------------------------------------+
typedef struct  {
	TipoElemento *Inicio;
	TipoElemento *Ultimo;
} ListaGenerica1;

// ---------------------------------------+
// Macros de la libreria                  |
// ---------------------------------------+
#define ListaGenerica1Principio(x)   ((*x).Inicio)
#define ListaGenerica1Final(x)       ((*x).Ultimo)
#define ListaGenerica1Vacia(x)       ((*x).Inicio == (*x).Ultimo)
#define ListaGenerica1Siguiente(x)   ((*x).Siguiente)
#define ListaGenerica1Elemento(x)    ((*((*x).Siguiente)).Apuntador)

// ---------------------------------------+
// Implementacion de las funciones        |
// ---------------------------------------+
WORD ListaGenerica1Anula( ListaGenerica1 *lista)
{
	TipoElemento *elem;
	elem= (TipoElemento *) malloc ( sizeof(TipoElemento));
	if (elem == NULL)
		return(LISTAG1_MEMORIA_INSUFICIENTE);
	else  {
		(*lista).Inicio = elem;
		(*lista).Apuntador = elem;
		return(LISTAG1_TODO_OK);
	}// end if
}// end ListaGenerica1Anula

WORD ListaGenerica1Anade( ListaGenerica1 *lista, TipoElemento *posicion, void *apuntador)
{
	TipoElemento *elem;
	elem = (TipoElemento *) malloc (sizeof(TipoElemento));
	if (elem == NULL)
		return(LISTAG1_MEMORIA_INSUFICIENTE);
	else  {
		(*elem).Siguiente = (*posicion).Siguiente;
		(*posicion).Siguiente = elem;
		if (posicion == ListaGenerica1Final(lista))
			(*lista).Ultimo = elem;
		return(LISTAG1_TODO_OK);
	}// end if
}// end ListaGenerica1Anade

void ListaGenerica1Elimina(ListaGenerica1 *lista, TipoElemento *posicion)
{
	TipoElemento *aux=(*posicion).Siguiente;
	(*posicion).Siguiente = (*aux).Siguiente;
	if( aux == ListaGenerica1Final(lista))
		(*lista).Ultimo = posicion;
	free(aux);
}// end ListaGenerica1Elimina

TipoElemento *ListaGenerica1Anterior( ListaGenerica1 *lista, TipoElemento *posicion)
{
	TipoElemento *aux=ListaGenerica1Principio(lista);
	while( posicion != ListaGenerica1Siguiente(aux))
		aux = ListaGenerica1Siguiente(aux);
	return(aux);
}// end ListaGenerica1Anterior


#endif	