// TIMER
// Esta libreria gestiona el uso de fechas y del tiempo.
// (C) Anubis Software Junio 1995

#ifndef TIMER
#define TIMER

// ---------------------------------+
// Inclusion de Anubis Librairies   |
// ---------------------------------+
#include "mdefs.h"

// ---------------------------------+
// Inclusion de librerias Borland   |
// ---------------------------------+

// -----------------------------------+
// Definicion de tipos de la librera |
// -----------------------------------+
typedef struct {
   WORD any;         //Ao; (1980 a 2099)
   BYTE mes;         //mes (1 a 12)
   BYTE dia;         //dia (1 a 31)
   BYTE diasem;      //dia de la semana ( 0=domingo, 1=lunes ...)
} Fecha;

typedef struct {
   BYTE hora;        //hora (0 a 23)
   BYTE minutos;     //minutos (0 a 59)
   BYTE segundos;    //segundos (0 a 59)
   BYTE centesimas;  //centesimas de segundo (0 a 99)
} Tiempo;

// ---------------------------+
// Definicin de prototipos   |
// ---------------------------+
#define ObtenerFechaE(x) ObtenerFecha(&(x.any),&(x.mes),&(x.dia),&(x.diasem))
// LLAMADA:    Fecha data;
//             ObtenerFechaE(data);
//    Esta funcin devuelve la fecha del sistema y la almacena
// en la estructura Fecha que se le pasa como parametro.
// Notese que es una forma especial de llamar al ObtenerFecha

void ObtenerFecha(WORD *,BYTE *,BYTE *,BYTE *);
//    LLAMADA: ObtenerFecha(&any,&mes,&dia,&diasem);
//    Esta funcin devuelve la  Fecha con los datos del
// sistema. Para ello utiliza la funcin 2Ah del DOS.

#define AsignarFechaE(x) AsignarFecha(x.any,x.mes,x.dia)
// LLAMADA:    Fecha data;
//             AsignarFechaE(data);
//    Esta funcin asigna a la fecha del sistema la fecha contenida
// en la esturctura data. Notese que el parametro diasem es obviado.
// Tambin se debe notar que la funcin no es ms que una llamada
// a la funcion AsignarFecha

boolean AsignarFecha(WORD,BYTE,BYTE);
// LLAMADA:      WORD ano;
//               BYTE mes;
//               BYTE dia;
//               AsignarFecha(ano,mes,dia);
//  Esta funcin asigna la fecha del sistema como la fecha que se
// le pasa como parametro. Utiliza la funcin 2Bh del DOS
// Si todo va bien devuelve TRUE.
// Si la fecha no es correcta devuelve FALSE.

#define ObtenerTiempoE(x) ObtenerTiempo(&(x.hora),&(x.minutos),&(x.segundos),&(x.centesimas))
// LLAMADA:      Tiempo time;
//               ObtenerTiempoE(time);
//   Esta funcin rellena la estructura Tiempo con los datos horarios
// del sistema. Notese que llama a la funcion ObtenerTiempo

void ObtenerTiempo(BYTE *, BYTE *, BYTE *, BYTE *);
// LLAMADA:      BYTE hora,minutos,segundos,centesimas;
//               ObtenerTiempo(&hora,&minutos,&segundos,&centesimas);
//   Esta funcion devuelve la hora del del sistema. Para ello utiliza
// la funcion 2Ch del DOS.

#define AsignarTiempoE(x) AsignarTiempo(x.hora,x.minutos,x.segundos,x.centesimas)
// LLAMADA:      Tiempo time;
//               AsignarTiempoE(time);
//   Esta funcin asigna el tiempo de la estructura time al sistema.
// Para ms informacin consultese AsignarTiempo

boolean AsignarTiempo(BYTE,BYTE,BYTE,BYTE);
// LLAMADA:      BYTE hora,minutos,segundos,centesimas;
//               AsignarTiempo(hora,minutos,segundos,centesimas);
//  Esta funcin asigna como horario del sistema al horario que se
// establece en los parametros. Para ello utiliza la funcin 2Dh del DOS
// Si todo va bien devuelve TRUE. Si no devuelve FALSE.

#endif
