// VSCROLL2.H
// (C) Anubis Software Julio 1995.

#ifndef VSCROLL2.H
#define VSCROLL2.H

//------------------------------------------+
// Inclusin de libreras Borland           |
// -----------------------------------------+

// -----------------------------------------+
// Inclusin de libreras Anubis Software   |
// -----------------------------------------+
#include "mdefs.h"
#include "listag2.h"
#include "ventana2.h"
#include "scancode.h"

// -----------------------------------------+
// Constantes de la libreria                |
// -----------------------------------------+
// Caracteristicas de los VSCROLLS
#define VSCROLL_SELECCIONABLE 1

// Valores devueltos por VScrollEvent
#define VSCROLL_NADA         20
#define VSCROLL_SIGUIENTE    21
#define VSCROLL_ANTERIOR     22
#define VSCROLL_CAMBIADO     23
#define VSCROLL_PULSADO      24
#define VSCROLL_SELECCIONADO 25


// Eventos que se le pasan a VScrollEvent
// Despus algunos se pasarn a VENTANA2.H
#define PULSAR_TECLA    0   
#define TECLA_RAPIDA    3


// -----------------------------------------+
// Definicin de tipos para la librera     |
// -----------------------------------------+

typedef struct {
   char Nombre[50];
   void *Apuntador;
} VScrollOption;

typedef struct {
   char AI,                        // El caracter de la  esquina sup izq
        AD,                        // El caracter de la esquina sup der
        AbI,                     // El caracter de la esquina inf izq
        AbD,                     // El caracter de la esquina inf der
        Horizontal,               // El caracter horizontal
        Vertical,                  // El caracter vertical
        FlechaArriba,            // La flecha sup de la barra desp
        FlechaAbajo,               // La flecha inf de la barra desp
        Desplazamiento,            // El caracter de desp
        CursorDesplazamiento;      // El cursor de desp
   BYTE  PosX,                     // Posicin de la esq sup izq
        PosY,                     // Posicion de la esquina sup izq
        Ancho,                     // Ancho del scroll
        Alto,                     // Alto del scroll
        PosRelLetra,                  // Posicion relativa de LActivacion
      PosXNombre,
      PosYNombre;
   char Nombre[40];               // El nombre del Scroll
   char LActivacion;               // La letra que lo activa
   char Caracteristicas;         // Ciertas caracteristicas que definen el scroll
   Ventana2 * Ventana;            // La ventana a que pertenece
   BYTE CTexto,                  // El color del texto
        CTexto1,                    // El color de la cadena de presentacin
        CFondo,                  // El color del fondo
        CSeleccionado,            // El color de fondo de la seleccion
        CLetra,                  // El color de la letra de activacion
        CNSeleccionado;            // El color del objeto cuando no es el seleccionado
   ListaGenerica2 Lista;
   TipoElemento *Actual;
   TipoElemento *AparY;
   boolean Estado;
   WORD TecRapid;                  // El scan code de la tecla rpida.
} VScroll2;

// ---------------------------------------------+
// Implementacin de las funciones              |
// ---------------------------------------------+
void VScrollInicializar(VScroll2 *);
void VScrollPulsar (VScroll2 *);
void VScrollFlechaArriba (VScroll2 *);
void VScrollFlechaAbajo (VScroll2 *);
void VScrollCursorDesplazamiento (VScroll2 *);
void VScrollPgUp (VScroll2 *);
void VScrollPgDown (VScroll2 *);
void DibujarVScroll( VScroll2 *);
void SeleccionarVScroll( VScroll2 *);
void DeseleccionarVScroll( VScroll2 *);
WORD VScrollEvent( VScroll2 *, WORD , WORD );


#endif
